
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>为Android Studio编写自定义Gradle插件的教程 / iVAN</title>

    <meta name="description" content="为Android Studio编写自定义Gradle插件的教程 Google已经建议Android开发全部转向Android Studio开发,Android Studio 是使用gradle编译.打包的,那么问题来了,gradle可是有一堆东西...,为了彻底了解gradle,今天就来学习下如何写自己的gradle插件(当然插件源码是使用groovy写的),先看如下代码目录: 如上图所示,plugin目录是插件源码目录,sample是用来测试插件的. 1.在目录plugin/src/main/groovy/com/micky/gradle/下新建插件类My">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">为Android Studio编写自定义Gradle插件的教程</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>Google已经建议Android开发全部转向Android Studio开发，Android Studio 是使用gradle编译、打包的，那么问题来了，gradle可是有一堆东西...，为了彻底了解gradle，今天就来学习下如何写自己的gradle插件（当然插件源码是使用groovy写的），先看如下代码目录：</p>
<p>如上图所示，plugin目录是插件源码目录，sample是用来测试插件的。</p>
<p>1、在目录plugin/src/main/groovy/com/micky/gradle/下新建插件类MyCustomPlugin.groovy</p>
<p>package com.micky.gradle; import org.gradle.api.*; class MyCustomPlugin implements Plugin&lt;Project&gt; { void apply(Project project) { project.task('myTask') &lt;&lt; { println &quot;Hi this is micky's plugin&quot; } } }<br />
<br />看看Plugin的源码，其实就是一接口</p>
<p>public interface Plugin&lt;T&gt; { /** * Apply this plugin to the given target object. * * @param target The target object */ void apply(T target); }<br />
<br />2、在目录plugin/src/main/resources/META-INF/gradle-plugins/下创建文件com.micky.mycustom.properties用来指定插件实现类</p>
<p>implementation-class=com.micky.gradle.MyCustomPlugin</p>
<p>特别注意下：文件名“com.micky.mycustom”即是以后我们在使用插件时的apply plugin 'java' 的java，这里我也是折腾了半天才得出的结果，坑啊。</p>
<p>3、一般情况下，我们还需要指定插件项目名称，在plugin目录下新建settings.gradle</p>
<p>rootProject.name='gradle-micky'</p>
<p>4、万事具备，就差编译了，编译需要在plugin目录下新建build.gradle</p>
<p>apply plugin: 'groovy' apply plugin: 'maven' dependencies { compile gradleApi() compile localGroovy() } repositories { mavenCentral() } group='com.micky' version='1.0.0' uploadArchives { repositories { mavenDeployer { repository(url: uri('../repo')) } } }<br />
<br />在这个脚本里使用groovy插件编译groovy源码，声明gradleAPI作为即时编译依赖，apply plugin: 'maven' 是用来创建一个插件jar文件并且存储在本地maven库里，本地maven库即我们在脚本里创建的&quot;../repo&quot;目录<br /> 执行命令:</p>
<p>gradle uploadArchives</p>
<p>5、以上4个步骤已经编译插件并上传到了本地库中，接下来就看看怎么使用插件，在sample目录下，新建build.gradle</p>
<p>buildscript { repositories { maven { url uri('../repo') } } dependencies { classpath group: 'com.micky', name: 'gradle-micky', version: '1.0.0' } } apply plugin: 'com.micky.mycustom'<br />
<br />6、执行命令</p>
<p>myTask即我们在MyCustomPlugin.groovy代码中创建的任务。</p>
<p>7、自定义Task</p>
<p>（1）copy一份改名CustomPluginTask</p>
<p>在plugin\src\main\groovy\com\micky\gradle目录创建源文件 MyCustomTask.groovy</p>
<p>package com.micky.gradle; import org.gradle.api.DefaultTask import org.gradle.api.tasks.TaskAction class MyCustomTask extends DefaultTask { @TaskAction void output() { println &quot;Hello this is my custom task output&quot; } }<br />
<br />（2）修改MyCustomPlugin.groovy</p>
<p>package com.micky.gradle; import org.gradle.api.*; class MyCustomPlugin implements Plugin&lt;Project&gt; { void apply(Project project) { project.task('customTask', type: MyCustomTask) } }<br />
<br />（3）修改plugin目录下的build.gradle，修改版本号</p>
<p>apply plugin: 'groovy' apply plugin: 'maven' dependencies { compile gradleApi() compile localGroovy() } repositories { mavenCentral() } group='com.micky' version='1.0.1' uploadArchives { repositories { mavenDeployer { repository(url: uri('../repo')) } } }<br />
<br />执行gradle uploadArchives 编译插件包<br /> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; <br /> （4）sample目录下的build.gradle</p>
<p>buildscript { repositories { maven { url uri('../repo') } } dependencies { classpath group: 'com.micky', name: 'gradle-micky', version: '1.0.1' } } apply plugin: 'com.micky.mycustom'&nbsp;<br />
<br />执行gradle customTask 结果如下：</p>
<p>8、向Plugin Task 传递参数<br /> （1）拷贝一份上面的代码，改名为CustomPluginTaskWithParam，修改plugin\src\main\groovy\com\micky\gradle\MyCustomPlugin.groovy</p>
<p>package com.micky.gradle; import org.gradle.api.*; class MyCustomPluginExtension { def message = &quot;From MyCustomPluginExtention&quot; def sender = &quot;MyCustomPluin&quot; } class MyCustomPlugin implements Plugin&lt;Project&gt; { void apply(Project project) { project.extensions.create('myArgs', MyCustomPluginExtension) project.task('customTask', type: MyCustomTask) } }<br />
<br />（2）修改plugin\src\main\groovy\com\micky\gradle\MyCustomTask.groovy</p>
<p>package com.micky.gradle; import org.gradle.api.DefaultTask import org.gradle.api.tasks.TaskAction class MyCustomTask extends DefaultTask { @TaskAction void output() { println &quot;Sender is ${project.myArgs.sender},\nmessage: ${project.myArgs.message}&quot; } }<br />
<br />（3）修改plugin/build.gradle</p>
<p>apply plugin: 'groovy' apply plugin: 'maven' dependencies { compile gradleApi() compile localGroovy() } repositories { mavenCentral() } group='com.micky' version='1.0.2' uploadArchives { repositories { mavenDeployer { repository(url: uri('../repo')) } } }<br />
<br />执行gradle uploadArchives 编译插件包</p>
<p>（4）修改sample/build.gradle</p>
<p>buildscript { repositories { maven { url uri('../repo') } } dependencies { classpath group: 'com.micky', name: 'gradle-micky', version: '1.0.2' } } apply plugin: 'com.micky.mycustom'<br />
<br />（5）执行gradle customTask，结果如下：</p>
<p>（6）在gradle文件配置参数</p>
<p>buildscript { repositories { maven { url uri('../repo') } } dependencies { classpath group: 'com.micky', name: 'gradle-micky', version: '1.0.2' } } apply plugin: 'com.micky.mycustom' myArgs { sender='Micky Liu' message='Gradle is so simple.' }<br />
<br />（7）执行gradle customTask，结果如下：</p>
<p>8、向Plugin Task 传递嵌套试复杂参数<br /> （1）拷贝一份上面的代码，改名为CustomPluginTaskWithNestParam，修改plugin\src\main\groovy\com\micky\gradle\MyCustomPlugin.groovy</p>
<p>package com.micky.gradle; import org.gradle.api.*; class MyNestPluginExtension { def receiver = &quot;Kate Zhou&quot; def email = &quot;KateZhou@gmail.com&quot; } class MyCustomPluginExtension { def message = &quot;From MyCustomPluginExtention&quot; def sender = &quot;MyCustomPluin&quot; } class MyCustomPlugin implements Plugin&lt;Project&gt; { void apply(Project project) { project.extensions.create('myArgs', MyCustomPluginExtension) project.myArgs.extensions.create('nestArgs', MyNestPluginExtension) project.task('customTask', type: MyCustomTask) } }<br />
<br />（2）修改MyCustomPlugin.groovy</p>
<p>package com.micky.gradle; import org.gradle.api.DefaultTask import org.gradle.api.tasks.TaskAction class MyCustomTask extends DefaultTask { @TaskAction void output() { println &quot;Sender is ${project.myArgs.sender} \nmessage: ${project.myArgs.message}&quot; println &quot;Receiver is ${project.myArgs.nestArgs.receiver} \nemail: ${project.myArgs.nestArgs.email}&quot; } }</p>
<p>（3）修改plugin/build.gradle</p>
<p>apply plugin: 'groovy' apply plugin: 'maven' dependencies { compile gradleApi() compile localGroovy() } repositories { mavenCentral() } group='com.micky' version='1.0.3' uploadArchives { repositories { mavenDeployer { repository(url: uri('../repo')) } } }<br />
<br />（4）执行gradle uploadArchives 编译插件包<br /> （5）修改sample/build.gradle</p>
<p>buildscript { repositories { maven { url uri('../repo') } } dependencies { classpath group: 'com.micky', name: 'gradle-micky', version: '1.0.3' } } apply plugin: 'com.micky.mycustom' myArgs { sender='Micky Liu' message='Gradle is so simple.' }<br />
<br />（6）执行执行gradle customTask，结果如下：</p>
<p>（7）在gradle文件配置参数</p>
<p>buildscript { repositories { maven { url uri('../repo') } } dependencies { classpath group: 'com.micky', name: 'gradle-micky', version: '1.0.3' } } apply plugin: 'com.micky.mycustom' myArgs { sender='Micky Liu' message='Gradle is so simple.' nestArgs { receiver='David Chen' email='David@126.com' } }<br />
<br />（8）执行gradle customTask，结果如下：</p>
<p>源码地址：https://github.com/mickyliu945/GradleCustomPlugin</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 11:40:27</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/gradle/" title="gradle">gradle</a>, <a href="https://www.iamivan.net/tag/androidstudio/" title="androidstudio">androidstudio</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>为Android Studio编写自定义Gradle插件的教程的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M9jqOXp.html" rel="bookmark">为Android Studio编写自定义Gradle插件的教程&lowbar;Android</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Google已经建议Android开发全部转向Android Studio开发,Android Studio 是使用gradle编译.打包的,那么问题来了,gradle可是有一堆东西...,为了彻底了解gradle,今天就来学习下如何写自己的gradle插件(当然插件源码是使用groovy写的),先看如下代码目录: 如上图所示,plugin目录是插件源码目录,sample是用来测试插件的. 1.在目录plugin/src/main/groovy/com/micky/gradle/下新建插件类My			</div>
		</article>
	</section>
						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MqWYLGz.html" rel="bookmark">Android studio编写简单的手电筒APP&lowbar;Android</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				很不错的手电筒APP,分享给大家,希望大家喜欢. 1. Java代码     package com.example.goo.gfire; import android.app.Activity; import android.hardware.Camera; import android.hardware.Camera.Parameters; import android.os.Bundle; import android.view.View; import android.widget.Bu			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M6wKdop.html" rel="bookmark">Android Studio手动配置Gradle的方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Gradle是一个基于Apache Ant和Apache Maven概念的项目自动化建构工具.它使用一种基于Groovy的特定领域语言(DSL)来声明项目设置,抛弃了基于XML的各种繁琐配置. 面向Java应用为主.当前其支持的语言限于Java.Groovy和Scala,计划未来将支持更多的语言. 下面是一些Gradle的功能 按约定声明构建和建设: 强大的支持多工程的构建: 强大的依赖管理(基于Apache Ivy),提供最大的便利去构建工程: 全力支持已有的 Maven 或者Ivy仓库基础建			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zOaOkRM.html" rel="bookmark">android studio 导入本地gradle包出错</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 android studio 导入本地gradle包出错 网上的方法用了好几个,一直无法解决问题,配置了GRADLE-HOME,Path.就是会报以下错误.希望大神指点一二.是windows8.1系统. 解决方案 我也遇到过这个问题,但也没解决,最终将studio卸载了,重新安装了一下studio和gradle			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pPBvKmb.html" rel="bookmark">Android Studio 中 build&period;gradle 中 dependencies 下的 comile 后面的内容的来源</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Android Studio 中 build.gradle 中 dependencies 下的 comile 后面的内容的来源 compile 'io.reactivex.rxjava2:rxandroid:2.0.1' compile 'io.reactivex.rxjava2:rxjava:2.1.0' 答案来自于:http://mvnrepository.com/ 你知道的名字应该是 rxandroid,而它依赖 rxjava,如果你想使用 rxjava 的最新版本,而不是 rxandro			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MRDeaez.html" rel="bookmark">android studios-现在android studio的sexy editor插件怎么没了？</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 现在android studio的sexy editor插件怎么没了? 现在android studio的sexy editor插件怎么没了?是被其他插件取代了么?? 解决方案 有啊 点那个browse repositories 解决方案二: 最好别用了,那个用久了会占用内存并且不会释放.你会发现时间久了电脑就会很卡!			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MgRrVZb.html" rel="bookmark">android studio 新建项目gradle几分钟才好？？（window平台）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 android studio 新建项目gradle几分钟才好??(window平台) 如题所问,是什么原因呢??有时一直gradle,而且有时运行项目的时候也会出现这种情况,请求大神答案.. 解决方案 android studio如何导入第三方库slidingmenu(gradle项目)Android Studio 导入 Gradle 项目 解决方案二: 1.5版本有这个问题2.0就好了,当然也看你机器快慢 解决方案三: 我现在就是2.0的版本			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M9XKd3b.html" rel="bookmark">android studio 3&period;0 gradle 打包脚本配置详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文介绍了android studio 3.0 gradle 打包脚本配置,分享给大家,具体如下: 修改输出的名字 保存输出的文件路径 def fileArray = [] //遍历输出文件 android.applicationVariants.all { variant -&gt; variant.outputs.all { output -&gt; def outputFile = output.outputFile if (outputFile != null &amp;&amp; outputF			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/ba6gZPM.html" rel="bookmark">Android Studio中build&period;gradle文件详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				首先,在Android studio的一个工程里,在Gradle Scripts目录下,有一个文件build.gradle(Module:app),打开.这里我随便选了一个工程的build.gradle文件做例子: apply plugin: 'com.android.application' android {     compileSdkVersion 21     buildToolsVersion &quot;21.1.2&quot;     defaultConfig {         min			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/5zOWGqz.html" rel="bookmark" class="title">openwrt ar9331 编程-openwrt-ar9331 使用设置</a>
					<div>
						问题描述 openwrt-ar9331 使用设置 openwrt AR9331的芯片有用的没,怎么设置.源代码怎么修改添加.谢谢!					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Lp5Y3Bp.html" rel="bookmark" class="title">想搞个手机答题之类的软件，不知道需要什么开发环境？</a>
					<div>
						问题描述 想搞个手机答题之类的软件,不知道需要什么开发环境? 最近想用手机开发个答题的软件,主要是选择题.不知道怎么搭建开发环境,怎么编写手机软件,准备先开发一个安卓版本的.希望做过的给指个道. 解决 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/dzZ406M.html" rel="bookmark" class="title">Photoshop给外景图片加上唯美的暖色逆光</a>
					<div>
						素材图片主色为冷色,调色的时候先把图片颜色转为暖色,然后在局部位置增加高光做出初步逆光效果,后期给轮廓部分增加较强的高光即可. 原图 最终效果 [1] [2] [3] [4] [5] [6]  下一页					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/vbQ25QM.html" rel="bookmark" class="title">用C&num;生成随机中文汉字验证码的基本原理</a>
					<div>
						汉字|随机|验证码|中文   前几天去申请免费QQ号码,突然发现申请表单中的验证码内容换成了中文,这叫真叫我大跌眼镜感到好笑,Moper上的猫儿们都大骂腾讯采用中文验证码.^_^ 我不得不佩服腾讯为了 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M62L0WM.html" rel="bookmark" class="title">php文件操作之小型留言本实例</a>
					<div>
						  本文实例讲述了php文件操作之小型留言本.分享给大家供大家参考.具体如下: Index.php文件如下: ? 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 & ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z72x8Rp.html" rel="bookmark" class="title">PS调出时尚性感模特灰暗大气欧美范后期调修教程</a>
					<div>
						原图分析: 第一眼看见摄影师这张作品时尚感的味道非常浓重,S型曲线配上迷离的眼神在加上豹纹外套和高腰裤的搭配给人一种性感时尚的混搭视觉冲击, 整体定位时尚欧美范. 调修思路: 第一眼看上作品背景的颜色 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pd605mb.html" rel="bookmark" class="title">Win8&period;1公用网络怎么改专用网络图文教程</a>
					<div>
						图1 在Win8.1网络连接中不再看到快捷的转换方式 通过网络共享中心我们可以看到目前所处的网络类型为公用网络连接,下面我们要做的就是将其设置为专用网络连接. 图2 当前Win8.1系统网络为公用网络 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkGD5yp.html" rel="bookmark" class="title">快速解决MindManager 15运行中的C&plus;&plus;错误</a>
					<div>
						  MindManager是一款应用性软件,它并不是独立于其他软件,需要其他软件的配合.MindManager的运行离不开C++,两者互相结合的过程难免会出现不相兼容的情况,本教程主讲如何处理Mind ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvGoBrp.html" rel="bookmark" class="title">关闭XP系统默认共享目录，保护系统安全</a>
					<div>
						随着互联网时代的来临,很多用户都有自己单独的一台笔记本电脑,互联网是一个精彩纷呈的世界,各式各样的人群都能在其中找到适合自己的土壤,不管是工作学习还是休闲娱乐,可是这也产生了一个问题,那就是互联网安全 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOldq9b.html" rel="bookmark" class="title">HTML Button自动刷新页面的问题</a>
					<div>
						一.问题 &lt;button class=&quot;am-btn am-btn-default am-btn-xs am-text-secondary&quot; data-id=&quot;99 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgVdP3b.html" rel="bookmark" class="title">微信模板消息推送&comma;苹果手机没效果</a>
					<div>
						问题描述 微信模板消息推送,苹果手机没效果 为什么我写的微信模板消息推送,消息提示安卓机子可显示,但是苹果手机就是空白的不显示呢? 解决方案 安卓微信和ios微信实现是有差别的,但微信服务器在收发消息 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrWZljp.html" rel="bookmark" class="title">设计-用C&plus;&plus;面向对象的方法访问硬件资源</a>
					<div>
						问题描述 用C++面向对象的方法访问硬件资源 最近在开发一个基于ATMega2560的单片机系统,因为外围模块比较多, 同时也想以后开发其它板子时,能够稍微修改上一次的代码就可以适用到新板子, 查阅很 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bB16wOz.html" rel="bookmark" class="title">VMware即时克隆如何助力桌面配置</a>
					<div>
						VMware即时克隆技术能够帮助IT进一步整合虚拟桌面资源,实现性能的最大化. 虚拟桌面的主线之一就是共享资源.远程桌面会话主机上的所有用户共享Windows服务器.VDI用户共享hypervisor ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bB1RWdz.html" rel="bookmark" class="title">C&plus;&plus;资源之不完全导引（完整版）</a>
					<div>
						 C++资源之不完全导引(完整版)来源:www.csdn.net撰文:曾毅.陶文声明:本文2004年5月首发于&lt;CSDN开发高手&gt;,版权归该杂志与&lt;程序员&gt;杂志社所有.---- ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlKvgYb.html" rel="bookmark" class="title">F8大会精彩看点：Facebook推出了这些新功能</a>
					<div>
						Facebook在旧金山举行F8年度开发者大会.以下是本次大会上Facebook发布的新功能看点: 1.Facebook发布Messenger聊天平台 Facebook向开发者展示了如何在Messen ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvmPB1b.html" rel="bookmark" class="title">英国著名智能搜索引擎公司Autonomy&amp;amp&semi;nbsp&semi;进入中国</a>
					<div>
						     新华网北京3月20日电(记者常晓华 段世文)英国著名的智能搜索引擎公司Autonomy执行总裁Lynch日前旋风式访问了中国,并与中国合作伙伴&quot;密谋&quot;后初步达成了合作意向 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmBq7Dz.html" rel="bookmark" class="title">有没有遇到这种UI问题的？</a>
					<div>
						问题描述 我把代码都找了一边,位置都改动了也没测出来到底哪出问题了,这个红点一直在图片内,改不过来了 解决方案 终于摸清楚了 ,原来是层次的问题 ,最底层的是 View ,然后view上有imageV ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdynvmz.html" rel="bookmark" class="title">azure-实际内存和配置不符？</a>
					<div>
						问题描述 实际内存和配置不符? 实际内存和配置不符? 解决方案 计算方法不一样,1000和1024的区别. 解决方案二: 工业计算内存是采用的1000这样计算比较方便,但是在计算机采用1024,所以会 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvnQJ9M.html" rel="bookmark" class="title">去啊总经理：淘宝旅行为啥不叫&OpenCurlyDoubleQuote;飞猪&rdquo;</a>
					<div>
						摘要: 阿里航旅事业群总经理李少华(花名忽必烈) 10月28日晚间消息, 阿里巴巴 集团今天宣布,将旗下航旅事业部升级为航旅事业群,淘宝旅行升级为全新独立品牌阿里旅行・去啊. 阿里航旅 阿里航旅事业群 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwJQA5p.html" rel="bookmark" class="title">请问SSH&plus;ajax&plus;json如何实现ajax分页查询？</a>
					<div>
						问题描述 请问SSH+ajax+json如何实现ajax分页查询? 请问SSH+ajax+json如何实现ajax分页查询?通过后台把list放到PageBean中进行分割,再把list传到前台,这种 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvYRY1b.html" rel="bookmark" class="title">谷歌确认正在开发Metro版Chrome浏览器</a>
					<div>
						新浪科技讯 北京时间3月13日早间消息,谷歌表示,正在针对Windows 8的Metro界面开发Chrome浏览器.此前Mozilla已经宣布,已开始开发Metro版火狐浏览器.谷歌一名发言人表示,这 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zV7Q7Vb.html" rel="bookmark" class="title">PHP异常处理浅析&lowbar;php实例</a>
					<div>
						PHP预定了两个异常类:Exception和ErrorException 复制代码 代码如下: Exception {     /* 属性 */     protected string $messa ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z44m5Yz.html" rel="bookmark" class="title">用jquery修复在iframe下的页面锚点失效问题&lowbar;jquery</a>
					<div>
						应用场景是:iframe页面没有滚动条,在父窗体中出现滚动条,锚点标记就会失效,因为,锚点是根据当前窗口滚动条滚动窗口的,成为子窗体后没有了滚动条,自然不会滚动. 解决办法是:用js判断页面是否被嵌套 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJOlwwb.html" rel="bookmark" class="title">GetModuleFileName替换GetCurrentDirectory打不开文件了？求问，谢谢</a>
					<div>
						问题描述 GetModuleFileName替换GetCurrentDirectory打不开文件了?求问,谢谢 #include #include //_T() #define ID_LIST 1 # ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvWLmWp.html" rel="bookmark" class="title">冯大辉：支付宝第1年差点被累死 阿里云是瞎折腾</a>
					<div>
						&amp;http://www.aliyun.com/zixun/aggregation/37954.html&quot;&gt;nbsp; 他是互联网圈子知名的技术专家,现在活跃于微博专职吐槽,并且 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNm937b.html" rel="bookmark" class="title">关于 throw new runtimeexception</a>
					<div>
						问题描述 在catch中thrownewruntimeexception有什么好处?当抛了这个异常方法为何不用写返回值了 解决方案 解决方案二:没有什么好坏之分,只有是否符合业务需求而已.但就你这个操 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXdoOAp.html" rel="bookmark" class="title">小银行青睐基于云的灾难恢复服务</a>
					<div>
						许多银行正开始使用云计算服务来满足其技术要求中一个很关键.很敏感的方面:灾难恢复. 依赖云计算的银行可以在由第三方管理的服务器上租用空间,而不是在组织内部管理服务器硬件.云计算服务有望为银行节省资金. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLBD5kb.html" rel="bookmark" class="title">智慧物联网 让城市感知和体验更美好</a>
					<div>
						智慧城市及物联网发展趋势 随着城镇化的快速发展,城市的人口和产业承载能力在不断提升:为使城市生产.生活.生态融合发展,更加宜居.宜业.宜游,城市正在努力使真实物理世界和网络虚拟空间之间信息通畅,使信息 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOWDXxz.html" rel="bookmark" class="title">专家称2015年智能终端占比50&percnt;低端手机是主流</a>
					<div>
						6月8日上午消息,在今天举行的&quot;TD智能终端技术发展研讨会&quot;上,工业和信息化部电信管理局巡视员张新生表示,如果在2015年智能终端占到终端总量的50%,低端手机将是主流. &quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmRZwaz.html" rel="bookmark" class="title">c&plus;&plus;读取一个文件，英文字母，完成以下功能</a>
					<div>
						问题描述 c++读取一个文件,英文字母,完成以下功能 1.统计26个字母出现频率 2.输入一个字母,找出和它最亲密的三个字母(最亲密的意思是:和它一起相邻出现的次数最多) 3.找出出现频率最高的五个单 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.033 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
